%{
/* 

  TinyCOBOL pre-processor parser

*/

//#define YYDEBUG 1


#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <stdarg.h>
#include <ctype.h>

#include "cobpp.h"

extern unsigned long lineCount;
extern unsigned long columnCount;
extern int copy_state_sw;
extern int copy_start_sw;
//extern char *include_filename;
extern char *include_cpybook;
extern char *include_cpylib;

extern int  yylex(void);
extern char *yytext;
extern void add_copy_replacement(char *, char *);

%}
%union {
    char *str;  /* string */
    int ival;   /* int */
}

%token <str> TOK_PSEUDO_TEXT,TOK_IDENTIFIER,TOK_LITERAL,TOK_WORD
%token <ival> ERROR,YYERROR_VERBOSE,YYDEBUG

%token TOK_COPY,TOK_PERIOD,TOK_OFF,TOK_BY,TOK_OF,TOK_IN
%token TOK_REPLACING,TOK_REPLACE
%token TOK_MISC

%type <str> pseudo_text,identifier,literal,word,name,library_name_opt


%%
%{
//void yyunion( YYSTYPE *to, YYSTYPE *from );
%}

root: statements
    | /* nill */
    ;

statements: statement
    | statements statement
    ;

statement: TOK_COPY 
      {
       if (globalEnvPtr->debugFlag != 0 ) {
         fprintf(stderr, "yytrace: TOK_COPY\n");
       }
      } 
      copy_statement TOK_PERIOD
      { 
       copy_state_sw--;
       copy_start_sw++;
      }
    | TOK_REPLACE replace_statement TOK_PERIOD
      { 
       copy_state_sw--;  
       copy_start_sw++;
      }
    | error
      {
        return 11;
      }
    | ERROR
      {
        return 2;
      }
    | YYERROR_VERBOSE
      {
        return 3;
      }
    ;

copy_statement: name library_name_opt 
    { 
     /*include_filename = $1; */ 
     include_cpybook  = $1;
     include_cpylib   = $2;
     if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: copy_statement: name=%s, lib=%s;\n",
                include_cpybook, 
                include_cpylib
                );
     }
    }
    TOK_REPLACING replacing_statement
    | name library_name_opt
    { 
     /*include_filename = $1;*/
     include_cpybook  = $1;
     include_cpylib   = $2;
     if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: copy_statement: name=%s, lib=%s;\n",
                include_cpybook, 
                include_cpylib
                );
     }
    }
    ;

replacing_statement: replacing_statements
    | replacing_statements  replacing_statement
    ;

replacing_statements: pseudo_text TOK_BY pseudo_text 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | pseudo_text TOK_BY identifier
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
   | pseudo_text TOK_BY literal
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
   | pseudo_text TOK_BY word
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | identifier  TOK_BY identifier 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | identifier  TOK_BY pseudo_text 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | identifier  TOK_BY literal 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | identifier  TOK_BY word 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | literal     TOK_BY literal 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | literal     TOK_BY pseudo_text 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | literal     TOK_BY identifier 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | literal     TOK_BY word
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | word        TOK_BY word 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | word TOK_BY pseudo_text 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | word TOK_BY identifier 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    | word TOK_BY literal 
      {
       add_copy_replacement($1,$3); 
       if (globalEnvPtr->debugFlag != 0 ) {
        fprintf(stderr, "yytrace: replacing_statements: \'%s\' BY \'%s\':\n", $1, $3);
       }
      }
    ;

library_name_opt: of_in name { $$=$2; }
    | { $$=NULL;  }
    ;

replace_statement: TOK_OFF { }
    | replace_statements
    ;

replace_statements: pseudo_text TOK_BY pseudo_text
    | pseudo_text TOK_BY pseudo_text replace_statements
    ;

name: literal { $$=$1; }
    | identifier { $$=$1; }
    ;

pseudo_text: TOK_PSEUDO_TEXT { $$=$1; }
    ;

identifier: TOK_IDENTIFIER { $$=$1; }
    ;

literal: TOK_LITERAL { $$=$1; }
    ;

word: TOK_WORD { $$=$1; }
    ;

of_in: TOK_OF
    | TOK_IN
    ;

%%


void yyerror(char *s)
{
  fprintf(stderr, "yyerror (%lu, %lu): %s :%s:\n", lineCount, columnCount, s, yytext);

  /* return 0; */
}
